// SPDX-FileCopyrightText: Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen
// SPDX-License-Identifier: BSD-3-Clause
#include "Basis_HGrad_HexI2Gradient.h"

const char *Basis_HGrad_HexI2Gradient =
"basisGradient[0 * 3 + 0] = -0.125 * (1.0 - ss) * (1.0 - tt) * (-rr - ss - tt - 2.0) -\n"
"  0.125 * (1.0 - rr) * (1.0 - ss) * (1.0 - tt);\n"
"basisGradient[0 * 3 + 1] = -0.125 * (1.0 - rr) * (1.0 - tt) * (-rr - ss - tt - 2.0) -\n"
"  0.125 * (1.0 - rr) * (1.0 - ss) * (1.0 - tt);\n"
"basisGradient[0 * 3 + 2] = -0.125 * (1.0 - rr) * (1.0 - ss) * (-rr - ss - tt - 2.0) -\n"
"  0.125 * (1.0 - rr) * (1.0 - ss) * (1.0 - tt);\n"
"\n"
"basisGradient[1 * 3 + 0] = 0.125 * (1.0 - ss) * (1.0 - tt) * (rr - ss - tt - 2.0) +\n"
"  0.125 * (1.0 + rr) * (1.0 - ss) * (1.0 - tt);\n"
"basisGradient[1 * 3 + 1] = -0.125 * (1.0 + rr) * (1.0 - tt) * (rr - ss - tt - 2.0) -\n"
"  0.125 * (1.0 + rr) * (1.0 - ss) * (1.0 - tt);\n"
"basisGradient[1 * 3 + 2] = -0.125 * (1.0 + rr) * (1.0 - ss) * (rr - ss - tt - 2.0) -\n"
"  0.125 * (1.0 + rr) * (1.0 - ss) * (1.0 - tt);\n"
"\n"
"basisGradient[2 * 3 + 0] = 0.125 * (1.0 + ss) * (1.0 - tt) * (rr + ss - tt - 2.0) +\n"
"  0.125 * (1.0 + rr) * (1.0 + ss) * (1.0 - tt);\n"
"basisGradient[2 * 3 + 1] = 0.125 * (1.0 + rr) * (1.0 - tt) * (rr + ss - tt - 2.0) +\n"
"  0.125 * (1.0 + rr) * (1.0 + ss) * (1.0 - tt);\n"
"basisGradient[2 * 3 + 2] = -0.125 * (1.0 + rr) * (1.0 + ss) * (rr + ss - tt - 2.0) -\n"
"  0.125 * (1.0 + rr) * (1.0 + ss) * (1.0 - tt);\n"
"\n"
"basisGradient[3 * 3 + 0] = -0.125 * (1.0 + ss) * (1.0 - tt) * (-rr + ss - tt - 2.0) -\n"
"  0.125 * (1.0 - rr) * (1.0 + ss) * (1.0 - tt);\n"
"basisGradient[3 * 3 + 1] = 0.125 * (1.0 - rr) * (1.0 - tt) * (-rr + ss - tt - 2.0) +\n"
"  0.125 * (1.0 - rr) * (1.0 + ss) * (1.0 - tt);\n"
"basisGradient[3 * 3 + 2] = -0.125 * (1.0 - rr) * (1.0 + ss) * (-rr + ss - tt - 2.0) -\n"
"  0.125 * (1.0 - rr) * (1.0 + ss) * (1.0 - tt);\n"
"\n"
"basisGradient[4 * 3 + 0] = -0.125 * (1.0 - ss) * (1.0 + tt) * (-rr - ss + tt - 2.0) -\n"
"  0.125 * (1.0 - rr) * (1.0 - ss) * (1.0 + tt);\n"
"basisGradient[4 * 3 + 1] = -0.125 * (1.0 - rr) * (1.0 + tt) * (-rr - ss + tt - 2.0) -\n"
"  0.125 * (1.0 - rr) * (1.0 - ss) * (1.0 + tt);\n"
"basisGradient[4 * 3 + 2] = 0.125 * (1.0 - rr) * (1.0 - ss) * (-rr - ss + tt - 2.0) +\n"
"  0.125 * (1.0 - rr) * (1.0 - ss) * (1.0 + tt);\n"
"\n"
"basisGradient[5 * 3 + 0] = 0.125 * (1.0 - ss) * (1.0 + tt) * (rr - ss + tt - 2.0) +\n"
"  0.125 * (1.0 + rr) * (1.0 - ss) * (1.0 + tt);\n"
"basisGradient[5 * 3 + 1] = -0.125 * (1.0 + rr) * (1.0 + tt) * (rr - ss + tt - 2.0) -\n"
"  0.125 * (1.0 + rr) * (1.0 - ss) * (1.0 + tt);\n"
"basisGradient[5 * 3 + 2] = 0.125 * (1.0 + rr) * (1.0 - ss) * (rr - ss + tt - 2.0) +\n"
"  0.125 * (1.0 + rr) * (1.0 - ss) * (1.0 + tt);\n"
"\n"
"basisGradient[6 * 3 + 0] = 0.125 * (1.0 + ss) * (1.0 + tt) * (rr + ss + tt - 2.0) +\n"
"  0.125 * (1.0 + rr) * (1.0 + ss) * (1.0 + tt);\n"
"basisGradient[6 * 3 + 1] = 0.125 * (1.0 + rr) * (1.0 + tt) * (rr + ss + tt - 2.0) +\n"
"  0.125 * (1.0 + rr) * (1.0 + ss) * (1.0 + tt);\n"
"basisGradient[6 * 3 + 2] = 0.125 * (1.0 + rr) * (1.0 + ss) * (rr + ss + tt - 2.0) +\n"
"  0.125 * (1.0 + rr) * (1.0 + ss) * (1.0 + tt);\n"
"\n"
"basisGradient[7 * 3 + 0] = -0.125 * (1.0 + ss) * (1.0 + tt) * (-rr + ss + tt - 2.0) -\n"
"  0.125 * (1.0 - rr) * (1.0 + ss) * (1.0 + tt);\n"
"basisGradient[7 * 3 + 1] = 0.125 * (1.0 - rr) * (1.0 + tt) * (-rr + ss + tt - 2.0) +\n"
"  0.125 * (1.0 - rr) * (1.0 + ss) * (1.0 + tt);\n"
"basisGradient[7 * 3 + 2] = 0.125 * (1.0 - rr) * (1.0 + ss) * (-rr + ss + tt - 2.0) +\n"
"  0.125 * (1.0 - rr) * (1.0 + ss) * (1.0 + tt);\n"
"\n"
"basisGradient[8 * 3 + 0] = -0.5 * rr * (1.0 - ss) * (1.0 - tt);\n"
"basisGradient[8 * 3 + 1] = -0.25 * (1.0 - rr * rr) * (1.0 - tt);\n"
"basisGradient[8 * 3 + 2] = -0.25 * (1.0 - rr * rr) * (1.0 - ss);\n"
"\n"
"basisGradient[9 * 3 + 0] = 0.25 * (1.0 - ss * ss) * (1.0 - tt);\n"
"basisGradient[9 * 3 + 1] = -0.5 * ss * (1.0 + rr) * (1.0 - tt);\n"
"basisGradient[9 * 3 + 2] = -0.25 * (1.0 + rr) * (1.0 - ss * ss);\n"
"\n"
"basisGradient[10 * 3 + 0] = -0.5 * rr * (1.0 + ss) * (1.0 - tt);\n"
"basisGradient[10 * 3 + 1] = 0.25 * (1.0 - rr * rr) * (1.0 - tt);\n"
"basisGradient[10 * 3 + 2] = -0.25 * (1.0 - rr * rr) * (1.0 + ss);\n"
"\n"
"basisGradient[11 * 3 + 0] = -0.25 * (1.0 - ss * ss) * (1.0 - tt);\n"
"basisGradient[11 * 3 + 1] = -0.5 * ss * (1.0 - rr) * (1.0 - tt);\n"
"basisGradient[11 * 3 + 2] = -0.25 * (1.0 - rr) * (1.0 - ss * ss);\n"
"\n"
"basisGradient[12 * 3 + 0] = -0.25 * (1.0 - ss) * (1.0 - tt * tt);\n"
"basisGradient[12 * 3 + 1] = -0.25 * (1.0 - rr) * (1.0 - tt * tt);\n"
"basisGradient[12 * 3 + 2] = -0.5 * tt * (1.0 - rr) * (1.0 - ss);\n"
"\n"
"basisGradient[13 * 3 + 0] = 0.25 * (1.0 - ss) * (1.0 - tt * tt);\n"
"basisGradient[13 * 3 + 1] = -0.25 * (1.0 + rr) * (1.0 - tt * tt);\n"
"basisGradient[13 * 3 + 2] = -0.5 * tt * (1.0 + rr) * (1.0 - ss);\n"
"\n"
"basisGradient[14 * 3 + 0] = 0.25 * (1.0 + ss) * (1.0 - tt * tt);\n"
"basisGradient[14 * 3 + 1] = 0.25 * (1.0 + rr) * (1.0 - tt * tt);\n"
"basisGradient[14 * 3 + 2] = -0.5 * tt * (1.0 + rr) * (1.0 + ss);\n"
"\n"
"basisGradient[15 * 3 + 0] = -0.25 * (1.0 + ss) * (1.0 - tt * tt);\n"
"basisGradient[15 * 3 + 1] = 0.25 * (1.0 - rr) * (1.0 - tt * tt);\n"
"basisGradient[15 * 3 + 2] = -0.5 * tt * (1.0 - rr) * (1.0 + ss);\n"
"\n"
"basisGradient[16 * 3 + 0] = -0.5 * rr * (1.0 - ss) * (1.0 + tt);\n"
"basisGradient[16 * 3 + 1] = -0.25 * (1.0 - rr * rr) * (1.0 + tt);\n"
"basisGradient[16 * 3 + 2] = 0.25 * (1.0 - rr * rr) * (1.0 - ss);\n"
"\n"
"basisGradient[17 * 3 + 0] = 0.25 * (1.0 - ss * ss) * (1.0 + tt);\n"
"basisGradient[17 * 3 + 1] = -0.5 * ss * (1.0 + rr) * (1.0 + tt);\n"
"basisGradient[17 * 3 + 2] = 0.25 * (1.0 + rr) * (1.0 - ss * ss);\n"
"\n"
"basisGradient[18 * 3 + 0] = -0.5 * rr * (1.0 + ss) * (1.0 + tt);\n"
"basisGradient[18 * 3 + 1] = 0.25 * (1.0 - rr * rr) * (1.0 + tt);\n"
"basisGradient[18 * 3 + 2] = 0.25 * (1.0 - rr * rr) * (1.0 + ss);\n"
"\n"
"basisGradient[19 * 3 + 0] = -0.25 * (1.0 - ss * ss) * (1.0 + tt);\n"
"basisGradient[19 * 3 + 1] = -0.5 * ss * (1.0 - rr) * (1.0 + tt);\n"
"basisGradient[19 * 3 + 2] = 0.25 * (1.0 - rr) * (1.0 - ss * ss);\n"
"";
