// SPDX-FileCopyrightText: Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen
// SPDX-License-Identifier: BSD-3-Clause
#include "Basis_HGrad_WdgC2Gradient.h"

const char *Basis_HGrad_WdgC2Gradient =
"basisGradient[0] = ((-3 + 4 * rr + 4 * ss) * (-1 + tt) * tt) / 2.;\n"
"basisGradient[1] = ((-3 + 4 * rr + 4 * ss) * (-1 + tt) * tt) / 2.;\n"
"basisGradient[2] = ((-1 + rr + ss) * (-1 + 2 * rr + 2 * ss) * (-1 + 2 * tt)) / 2.;\n"
"\n"
"basisGradient[3] = ((-1 + 4 * rr) * (-1 + tt) * tt) / 2.;\n"
"basisGradient[4] = 0.;\n"
"basisGradient[5] = (rr * (-1 + 2 * rr) * (-1 + 2 * tt)) / 2.;\n"
"\n"
"basisGradient[6] = 0.;\n"
"basisGradient[7] = ((-1 + 4 * ss) * (-1 + tt) * tt) / 2.;\n"
"basisGradient[8] = (ss * (-1 + 2 * ss) * (-1 + 2 * tt)) / 2.;\n"
"\n"
"basisGradient[9] = ((-3 + 4 * rr + 4 * ss) * tt * (1 + tt)) / 2.;\n"
"basisGradient[10] = ((-3 + 4 * rr + 4 * ss) * tt * (1 + tt)) / 2.;\n"
"basisGradient[11] = ((-1 + rr + ss) * (-1 + 2 * rr + 2 * ss) * (1 + 2 * tt)) / 2.;\n"
"\n"
"basisGradient[12] = ((-1 + 4 * rr) * tt * (1 + tt)) / 2.;\n"
"basisGradient[13] = 0.;\n"
"basisGradient[14] = (rr * (-1 + 2 * rr) * (1 + 2 * tt)) / 2.;\n"
"\n"
"basisGradient[15] = 0.;\n"
"basisGradient[16] = ((-1 + 4 * ss) * tt * (1 + tt)) / 2.;\n"
"basisGradient[17] = (ss * (-1 + 2 * ss) * (1 + 2 * tt)) / 2.;\n"
"\n"
"basisGradient[18] = -2 * (-1 + 2 * rr + ss) * (-1 + tt) * tt;\n"
"basisGradient[19] = -2 * rr * (-1 + tt) * tt;\n"
"basisGradient[20] = 2 * rr * (-1 + rr + ss) * (1 - 2 * tt);\n"
"\n"
"basisGradient[21] = 2 * ss * (-1 + tt) * tt;\n"
"basisGradient[22] = 2 * rr * (-1 + tt) * tt;\n"
"basisGradient[23] = 2 * rr * ss * (-1 + 2 * tt);\n"
"\n"
"basisGradient[24] = -2 * ss * (-1 + tt) * tt;\n"
"basisGradient[25] = -2 * (-1 + rr + 2 * ss) * (-1 + tt) * tt;\n"
"basisGradient[26] = 2 * ss * (-1 + rr + ss) * (1 - 2 * tt);\n"
"\n"
"basisGradient[27] = -(-3 + 4 * rr + 4 * ss) * (-1 + tt * tt);\n"
"basisGradient[28] = -(-3 + 4 * rr + 4 * ss) * (-1 + tt * tt);\n"
"basisGradient[29] = -2 * (1 + 2 * rr * rr - 3 * ss + 2 * ss * ss + rr * (-3 + 4 * ss)) * tt;\n"
"\n"
"basisGradient[30] = -(-1 + 4 * rr) * (-1 + tt * tt);\n"
"basisGradient[31] = 0;\n"
"basisGradient[32] = 2 * (1 - 2 * rr) * rr * tt;\n"
"\n"
"basisGradient[33] = 0;\n"
"basisGradient[34] = -(-1 + 4 * ss) * (-1 + tt * tt);\n"
"basisGradient[35] = 2 * (1 - 2 * ss) * ss * tt;\n"
"\n"
"basisGradient[36] = -2 * (-1 + 2 * rr + ss) * tt * (1 + tt);\n"
"basisGradient[37] = -2 * rr * tt * (1 + tt);\n"
"basisGradient[38] = -2 * rr * (-1 + rr + ss) * (1 + 2 * tt);\n"
"\n"
"basisGradient[39] = 2 * ss * tt * (1 + tt);\n"
"basisGradient[40] = 2 * rr * tt * (1 + tt);\n"
"basisGradient[41] = 2 * rr * ss * (1 + 2 * tt);\n"
"\n"
"basisGradient[42] = -2 * ss * tt * (1 + tt);\n"
"basisGradient[43] = -2 * (-1 + rr + 2 * ss) * tt * (1 + tt);\n"
"basisGradient[44] = -2 * ss * (-1 + rr + ss) * (1 + 2 * tt);\n"
"\n"
"basisGradient[45] = 4 * (-1 + 2 * rr + ss) * (-1 + tt * tt);\n"
"basisGradient[46] = 4 * rr * (-1 + tt) * (1 + tt);\n"
"basisGradient[47] = 8 * rr * (-1 + rr + ss) * tt;\n"
"\n"
"basisGradient[48] = -4 * ss * (-1 + tt) * (1 + tt);\n"
"basisGradient[49] = -4 * rr * (-1 + tt) * (1 + tt);\n"
"basisGradient[50] = -8 * rr * ss * tt;\n"
"\n"
"basisGradient[51] = 4 * ss * (-1 + tt) * (1 + tt);\n"
"basisGradient[52] = 4 * (-1 + rr + 2 * ss) * (-1 + tt * tt);\n"
"basisGradient[53] = 8 * ss * (-1 + rr + ss) * tt;\n"
"";
