// java wrapper for vtkConstantLongArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkConstantLongArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataArray_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkConstantLongArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkConstantLongArray",dType)) { return me; }
  if ((res= vtkDataArray_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkConstantLongArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkConstantLongArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkConstantLongArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkConstantLongArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkConstantLongArray_GetDataType_14(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataType();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkConstantLongArray_GetValue_15(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  long   temp20;
  temp0 = id0;

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkConstantLongArray_GetValueRange_16(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  long * temp20;
  temp0 = id0;

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueRange(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<jlong*>(temp20), 2);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkConstantLongArray_GetValueRange_17(JNIEnv* env, jobject obj)
{
  long * temp20;

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueRange();
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<jlong*>(temp20), 2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkConstantLongArray_ExtendedNew_18(JNIEnv* env, jobject obj)
{
  vtkConstantLongArray * temp20;

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ExtendedNew();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkConstantLongArray_FastDownCast_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractArray * temp0;
  vtkConstantLongArray * temp20;
  temp0 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FastDownCast(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkConstantLongArray_ConstructBackend_110(JNIEnv* env, jobject obj,jlong id0)
{
  long   temp0;
  temp0 = id0;

  vtkConstantLongArray* op = static_cast<vtkConstantLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ConstructBackend(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkConstantLongArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkConstantLongArray::New());
}
