// java wrapper for vtkHyperTreeGridGeometricLocator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkHyperTreeGridGeometricLocator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkHyperTreeGridLocator_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkHyperTreeGridGeometricLocator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkHyperTreeGridGeometricLocator",dType)) { return me; }
  if ((res= vtkHyperTreeGridLocator_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHyperTreeGridGeometricLocator* op = static_cast<vtkHyperTreeGridGeometricLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHyperTreeGridGeometricLocator* op = static_cast<vtkHyperTreeGridGeometricLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHyperTreeGridGeometricLocator* op = static_cast<vtkHyperTreeGridGeometricLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHyperTreeGridGeometricLocator* op = static_cast<vtkHyperTreeGridGeometricLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_SetHTG_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid * temp0;
  temp0 = static_cast<vtkHyperTreeGrid*>(vtkJavaGetPointerFromObject(env, id0));

  vtkHyperTreeGridGeometricLocator* op = static_cast<vtkHyperTreeGridGeometricLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetHTG(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_Search_15(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkHyperTreeGridGeometricLocator* op = static_cast<vtkHyperTreeGridGeometricLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Search(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_Search_16(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1)
{
  double temp0[3];
  vtkHyperTreeGridNonOrientedGeometryCursor * temp1;
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkHyperTreeGridNonOrientedGeometryCursor*>(vtkJavaGetPointerFromObject(env, id1));

  vtkHyperTreeGridGeometricLocator* op = static_cast<vtkHyperTreeGridGeometricLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Search(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_IntersectWithLine_17(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jdouble id2,jobject id3,jobject id4,jobject id5)
{
  double temp0[3];
  double temp1[3];
  double   temp2;
  vtkPoints * temp3;
  vtkIdList * temp4;
  vtkGenericCell * temp5;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  temp2 = id2;
  temp3 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id3));
  temp4 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id4));
  temp5 = static_cast<vtkGenericCell*>(vtkJavaGetPointerFromObject(env, id5));

  vtkHyperTreeGridGeometricLocator* op = static_cast<vtkHyperTreeGridGeometricLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IntersectWithLine(temp0,temp1,temp2,temp3,temp4,temp5);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkHyperTreeGridGeometricLocator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkHyperTreeGridGeometricLocator::New());
}
